Package org.zkoss.web.servlet.dsp

## Class ExtendletDspContext

- java.lang.Object
- - org.zkoss.web.servlet.dsp.ServletDspContext
  - - org.zkoss.web.servlet.dsp.ExtendletDspContext

- All Implemented Interfaces:
    `DspContext`, `RequestContext`

      public class ExtendletDspContext
      extends ServletDspContext

  Extendlet-based DSP context.
  Since:
    3.5.2
  Author:
    tomyeh

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ExtendletDspContext​(ExtendletContext webctx, javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response, java.lang.String path, java.io.Writer out)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.lang.String` | `encodeURL​(java.lang.String uri)` | Returns the encoded URL.
    `void` | `include​(java.lang.String uri, java.util.Map params)` | Includes the specified URI and render the result to the specified output.

    - ### Methods inherited from class org.zkoss.web.servlet.dsp.ServletDspContext

      `getLocator, getOut, getRequest, getResponse, getServletContext, getVariableResolver, isIncluded, setContentType, setOut`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ExtendletDspContext

          public ExtendletDspContext​(ExtendletContext webctx,
                                     javax.servlet.http.HttpServletRequest request,
                                     javax.servlet.http.HttpServletResponse response,
                                     java.lang.String path,
                                     java.io.Writer out)

  - ### Method Detail

    - #### encodeURL

          public java.lang.String encodeURL​(java.lang.String uri)
                                     throws javax.servlet.ServletException,
                                            java.io.IOException

      Description copied from interface: `DspContext`
      Returns the encoded URL. The returned URL is also encoded with HttpServletResponse.encodeURL.
      Specified by:
        `encodeURL` in interface `DspContext`
      Overrides:
        `encodeURL` in class `ServletDspContext`
      Parameters:
        `uri` - it must be empty or starts with "/". It might contain "*" for current browser code and Locale.
      Returns:
        the complete URL (excluding the machine name). It includes the context path and the servlet to interpret this extended resource.
      Throws:
        `javax.servlet.ServletException`
        `java.io.IOException`

    - #### include

          public void include​(java.lang.String uri,
                              java.util.Map params)
                       throws javax.servlet.ServletException,
                              java.io.IOException

      Description copied from interface: `DspContext`
      Includes the specified URI and render the result to the specified output.
      Specified by:
        `include` in interface `DspContext`
      Overrides:
        `include` in class `ServletDspContext`
      Parameters:
        `uri` - the URI to include. It is OK to relevant (without leading '/'). If starts with "/", the context path of request is assumed. To reference to foreign context, use "~ctx/" where ctx is the context path of the foreign context (without leading '/').
        `params` - a map of parameters, or null to ignore. The map is passed thru the request attribute called arg.
      Throws:
        `javax.servlet.ServletException`
        `java.io.IOException`